<template>
    <v-layout justify-center row>

        <v-flex sm12 md8 lg6 v-bind:class="containerClasses" transition="slide-y-transition">
            <v-expand-transition>
                <v-alert v-model="error" type="error">Teil on võimalik luua vaid 3 hääletust.</v-alert>
            </v-expand-transition>
            <v-expand-transition>
                <add-vote v-model="newVote"
                          v-if="!(Object.entries(newVote).length === 0 && newVote.constructor === Object)"
                          @cancel="newVote = {}" @onSave="newVote = {}"></add-vote>
            </v-expand-transition>

            <v-slide-y-transition
                    class="py-0 ma-0"
                    group
            >
                <v-alert key="alert" type="warning" :value="getVotes.length === 0 && !isLoading">Hääletused puuduvad!</v-alert>
                <vote v-for="(vote, index) in getVotes"
                      v-if="!vote.add"
                      :key="vote.id"
                      :id="vote.id"
                      :title="vote.title"
                      :description="vote.description"
                      :yes="positiveVotes(vote.id)"
                      :no="negativeVotes(vote.id)"
                      :img="vote.img"
                      :created_at="vote.created_at"
                      :created_by="vote.created_by_user"
                ></vote>

            </v-slide-y-transition>
            <v-expand-transition>
                <v-progress-linear v-show="isLoading" :indeterminate="true" class="mb-0"></v-progress-linear>
            </v-expand-transition>
            <v-fab-transition>
                <v-btn fab
                       dark
                       color="primary"
                       @click="addNewVote"
                       fixed
                       bottom
                       right
                       v-show="(Object.entries(newVote).length === 0 && newVote.constructor === Object) && !isLoading"
                >
                    <v-icon dark>add</v-icon>
                </v-btn>
            </v-fab-transition>
        </v-flex>
    </v-layout>
</template>

<script>
    import {mapGetters} from "vuex";
    import Vote from "../components/Vote";
    import AddVote from "../components/AddVote";
    import axios from "axios";

    export default {
        name: "Votes",

        components: {
            Vote,
            AddVote
        },

        data() {
            return {
                dialog: false,
                isAddEditActive: false,
                votes: [],
                newVote: {},
                isLoading: false,
                error: null
            }
        },
        created() {
            //When page is loaded then make a request for all the votes
            this.isLoading = true;
            this.$store.dispatch('voting/load').then(() => this.isLoading = false);
        },
        computed: {
            ...mapGetters([
                'user', 'isStaff'
            ]),
            ...mapGetters('voting', {
                getVotes: 'all',
                positiveVotes: 'positiveVotes',
                negativeVotes: 'negativeVotes',
                userVotesCount: 'currentUserVotesCount',
            }),
            containerClasses() {
                const smAnDown = this.$vuetify.breakpoint.smAndDown;

                return {
                    'elevation-4': !smAnDown,
                    'ma-1': !smAnDown,
                    'pa-3': !smAnDown,
                    'ma-0': smAnDown,
                    'pa-0': smAnDown
                }
            }
        },
        methods: {
            addNewVote() {
                if (!this.isStaff && this.userVotesCount(this.user.id) >= 3) {
                    this.error = true;
                } else {
                    this.newVote = {
                        title: '',
                        description: '',
                        img: '',
                        isActive: true
                    }
                }


            },
            cancelAddEdit(index) {
                this.votes = this.votes.filter((vote, voteIndex) => voteIndex !== index);
                this.isAddEditActive = false;
            }
        }
    }
</script>

<style scoped>

</style>
